# kdecore Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KSelectionOwner Class Reference

This class implements claiming and owning manager selections, as described in the ICCCM, section 2.8. ICCCM manager selection owner. More...

`#include <kmanagerselection.h>`

Inheritance diagram for KSelectionOwner:

[legend]
Collaboration diagram for KSelectionOwner:

[legend]
List of all members.

## Signals

void | lostOwnership ()

## Public Member Functions

| KSelectionOwner (Atom selection, int screen=-1, QObject *parent=NULL)
| KSelectionOwner (const char *selection, int screen=-1, QObject *parent=NULL)
virtual | ~KSelectionOwner ()
bool | claim (bool force, bool force_kill=true)
void | release ()
Window | ownerWindow () const
bool | filterEvent (XEvent *ev_P)

## Protected Member Functions

virtual bool | handleMessage (XEvent *ev)
virtual bool | genericReply (Atom target, Atom property, Window requestor)
virtual void | replyTargets (Atom property, Window requestor)
virtual void | getAtoms ()
void | setData (long extra1, long extra2)
virtual void | virtual_hook (int id, void *data)

## Detailed Description

This class implements claiming and owning manager selections, as described in the ICCCM, section 2.8. ICCCM manager selection owner.

The selection atom is passed to the constructor, claim() attemps to claim ownership of the selection, release() gives up the selection ownership. Signal lostOwnership() is emitted when the selection is claimed by another owner.

Since:
  3.2

Definition at line 46 of file kmanagerselection.h.

## Constructor & Destructor Documentation

KSelectionOwner::KSelectionOwner | ( | Atom | selection,
|  | int | screen = `-1`,
|  | QObject * | parent = `NULL`
| ) |

This constructor initializes the object, but doesn't perform any operation on the selection.

Parameters:

  | selection | atom representing the manager selection
  | screen | X screen, or -1 for default
  | parent | parent object, or NULL if there is none

Definition at line 76 of file kmanagerselection.cpp.

KSelectionOwner::KSelectionOwner | ( | const char * | selection,
|  | int | screen = `-1`,
|  | QObject * | parent = `NULL`
| ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

This constructor accepts the selection name and creates the appropriate atom for it automatically.

Parameters:

  | selection | name of the manager selection
  | screen | X screen, or -1 for default
  | parent | parent object, or NULL if there is none

Definition at line 87 of file kmanagerselection.cpp.

KSelectionOwner::~KSelectionOwner | ( |  | ) | `[virtual]`

| Destructor. Calls release(). Definition at line 98 of file kmanagerselection.cpp. References release().

## Member Function Documentation

bool KSelectionOwner::claim | ( | bool | force,
|  | bool | force_kill = `true`
| ) |

This function attemps to claim ownership of the manager selection, using the current X timestamp.

If `force` is false, and the selection is already owned, the selection is not claimed, and false is returned. If claiming is forced and the selection is owned by another client, it is waited for up to 1 second for the previous owner to disown the selection, if `force_kill` is true, and the previous owner fails to disown the selection in time, it will be forcibly killed. True is returned after successfully claiming ownership of the selection.

Definition at line 104 of file kmanagerselection.cpp.

References getAtoms(), and release().

void KSelectionOwner::release | ( |  | ) |

| If the selection is owned, the ownership is given up. Definition at line 182 of file kmanagerselection.cpp. Referenced by claim(), and ~KSelectionOwner().

Window KSelectionOwner::ownerWindow | ( |  | ) | const

| If the selection is owned, returns the window used internally for owning the selection. Definition at line 191 of file kmanagerselection.cpp.

void KSelectionOwner::lostOwnership | ( |  | ) | `[signal]`

| This signal is emitted if the selection was owned and the ownership has been lost due to another client claiming it, this signal is emitted. IMPORTANT: It's not safe to delete the instance in a slot connected to this signal.

bool KSelectionOwner::handleMessage | ( | XEvent * | ev | ) | `[protected, virtual]`

| Called for every X event received on the window used for owning the selection. If true is returned, the event is filtered out. Definition at line 247 of file kmanagerselection.cpp.

bool KSelectionOwner::genericReply | ( | Atom | target,
|  | Atom | property,
|  | Window | requestor
| ) | `[protected, virtual]`

Called when a SelectionRequest event is received.

A reply should be sent using the selection handling mechanism described in the ICCCM section 2.

Parameters:

  | target | requested target type
  | property | property to use for the reply data
  | requestor | requestor window

Definition at line 339 of file kmanagerselection.cpp.

void KSelectionOwner::replyTargets | ( | Atom | property,
|  | Window | requestor
| ) | `[protected, virtual]`

| Called to announce the supported targets, as described in the ICCCM section 2.6. The default implementation announces the required targets MULTIPLE, TIMESTAMP and TARGETS. Definition at line 331 of file kmanagerselection.cpp.

void KSelectionOwner::getAtoms | ( |  | ) | `[protected, virtual]`

| Called to create atoms needed for claiming the selection and communication using the selection handling mechanism. The default implementation must be called if reimplemented. This method may be called repeatedly. Definition at line 344 of file kmanagerselection.cpp. Referenced by claim().

void KSelectionOwner::setData | ( | long | extra1,
|  | long | extra2
| ) | `[protected]`

| Sets extra data to be sent in the message sent to root window after successfully claiming a selection. These extra data are in data.l[3] and data.l[4] fields of the XClientMessage. Definition at line 198 of file kmanagerselection.cpp.

The documentation for this class was generated from the following files:

- kmanagerselection.h
- kmanagerselection.cpp

This file is part of the documentation for kdecore Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:18:59 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003